/*
 *  Yet another ADO wrapper class
 *  (c) 2008 Carlos Mora (carlosantoniomora@yahoo.es - harbouradvisor.blogspot.com )
 *  based and inspired in the work of Jos Luis Capel and Gabriel Maim (Biel)
 *
 */

#include "MyInclude.ch"
#include "hbclass.ch"
#include "ado.ch"

CLASS ADMRecordSet

   DATA oRS       AS OBJECT
   DATA oConn     AS OBJECT

   METHOD New( oConn )

   METHOD Open( cSqlStm, nCursorType, nLockType, nOptions )
   METHOD GoTop()
   METHOD GoBottom()
   METHOD Skip()
   METHOD Eof()
   METHOD Bof()
   METHOD FieldGet( n )
   METHOD FieldPut( n, uValue )
   METHOD FCount()

   // METHOD FieldBlock()
   Method RecNo()
   Message RecCount Method LastRec()
   Method LastRec()
   Method Goto()
   METHOD FieldName()

   METHOD Close()
   METHOD Append()
   METHOD Save()

   ERROR HANDLER OnError( uParam1 )

ENDCLASS

METHOD New( oConn ) CLASS ADMRecordSet
   LOCAL oError

   TRY
      ::oRs := OleWEvent():New("ADODB.Recordset")
   CATCH oError
      Alert( oError:Operation,"Ado RecordSet NEW")

   END

   ::oConn:= oConn

RETURN Self


METHOD Open( cSqlStm, nCursorType, nLockType, nOptions ) CLASS ADMRecordSet

   LOCAL oError
   LOCAL lResult

   DEFAULT nCursorType TO adOpenKeyset
   DEFAULT nLockType   TO adLockOptimistic
   DEFAULT nOptions    TO adCmdUnknown // && adOptionUnspecified

   lResult := .T.

   TRY
      ::oRs:Open( cSqlStm, ::oConn:oConn, nCursorType, nLockType, nOptions )
   CATCH oError
      lResult := .F.
      Alert( oError:Operation, { "Ado RecordSet OPEN" } )
   END

RETURN lResult

METHOD Close( ) CLASS ADMRecordSet
   LOCAL oError, lResult := .T.

   TRY
      ::oRs:Close()
   CATCH oError
      lResult := .F.
      Alert(oError:Operation,"Ado RecordSet")
   END

RETURN lResult


METHOD Append( ) CLASS ADMRecordSet
   LOCAL oError, lResult := .T.

   TRY
      ::oRs:AddNew()
   CATCH oError
      lResult := .F.
      Alert(oError:Operation,"Ado RecordSet")
   END

RETURN lResult

METHOD Save( ) CLASS ADMRecordSet
   LOCAL oError, lResult := .T.

   TRY
      ::oRs:Update()
   CATCH oError
      lResult := .F.
      Alert(oError:Operation,"Ado RecordSet")
   END

RETURN lResult


METHOD OnError( uParam1 ) CLASS ADMRecordSet
   local cMsg   := __GetMessage()
   local oField

   if SubStr( cMsg, 1, 1 ) == "_"

      cMsg:= SubStr( cMsg, 2 )

      if ( oField:= ::oRS:Fields( cMsg ) ) != NIL
         oField:Value:= uParam1
      else
         // _ClsSetError( _GenError( 1005, ::ClassName(), SubStr( cMsg, 2 ) ) )
         RETURN NIL
      endif

   else

      if ( oField:= ::oRS:Fields( cMsg ) ) != NIL
      else
         // _ClsSetError( _GenError( 1004, ::ClassName(), cMsg ) )
         RETURN NIL
      endif
   endif

RETURN oField:Value

METHOD GoTop()     CLASS ADMRecordSet
RETURN ::oRS:MoveFirst()

METHOD GoBottom()  CLASS ADMRecordSet
RETURN ::oRS:MoveLast()

METHOD Skip( n )   CLASS ADMRecordSet
   If n == NIL
      n:= 1
   EndIf
RETURN ::oRS:Move( n, 0 ) // mover desde la posicion actual

METHOD Eof()       CLASS ADMRecordSet
RETURN ::oRS:Eof()

METHOD Bof()       CLASS ADMRecordSet
RETURN ::oRS:Bof()

METHOD FCount() CLASS ADMRecordSet
RETURN ::oRs:Fields:Count

METHOD FieldGet( n ) CLASS ADMRecordSet
RETURN ::oRs:Fields(n-1):Value

METHOD FieldName( n ) CLASS ADMRecordSet
RETURN ::oRs:Fields(n-1):Name

METHOD FieldPut( n, uValue ) CLASS ADMRecordSet
RETURN ::oRs:Fields(n-1):Value:= uValue

METHOD RecNo() CLASS ADMRecordSet
RETURN ::oRs:AbsolutePosition

METHOD LastRec() CLASS ADMRecordSet
RETURN ::oRs:RecordCount()

METHOD Goto( nRec ) CLASS ADMRecordSet
RETURN ::oRs:AbsolutePosition:= nRec