/*
 * Common includes for Harbour
 *
 */



#ifndef CRLF
   #define CRLF HB_OSNewLine()
#endif

#xcommand DEFAULT <x1> TO <v1> [, <xn> TO <vn> ] => ;
          IF <x1> == Nil ; <x1> := <v1> ; ENDIF     ;
          [; IF <xn> == Nil ; <xn> := <vn> ; ENDIF ]

#ifndef __XHARBOUR__

   #xcommand TRY              => BEGIN SEQUENCE WITH {|__o| break(__o) }
   #xcommand CATCH [<!oErr!>] => RECOVER [USING <oErr>] <-oErr->
   #xcommand FINALLY          => ALWAYS

#endif

#ifdef __NODEBUG__
   #xcommand DEBUG <cString1>[, <cStringN>] =>
#else
   #translate ASSTRING( <x> ) => If( <x> == NIL, 'NIL', Transform( <x> , NIL ) ) + CRLF

   #xcommand DEBUG <cString1>[, <cStringN>] ;
            => ;
             OutputDebugString( ProcName() +"("+LTrim(Str(ProcLine())) +") - " ) ; OutputDebugString( <"cString1">+" ("+ValType( <cString1> )+"): " ) ; OutputDebugString( ASSTRING( <cString1> ) ) ;
             [ ; OutputDebugString( ProcName() +"("+LTrim(Str(ProcLine())) +") - " ) ; OutputDebugString( <"cStringN">+" ("+ValType( <cStringN> )+"): " ) ; OutputDebugString( ASSTRING( <cStringN> ) ) ]

#endif
