/*
 * Proyecto: adolib
 * Fichero: ado.ch
 * Descripcin: Fichero de cabecera con definiciones ADO
 * Autor: Jos Luis Capel - www.capelblog.com
 * Fecha: 13/11/2005
 * CopyRight: Jos Luis Capel - 2005 Todos los derechos reservados al autor
 */


// Para el estado de Connection.
#define     adStateClosed              0  // The object is closed
#define     adStateOpen                1  // The object is open
#define     adStateConnecting          2  // The object is connecting
#define     adStateExecuting           4  // The object is executing a command
#define     adStateFetching            8  // The rows of the object are being retrieved

// Para el mtodo Open de Connection.  Modo apertura.
#define     adAsyncConnect             16
#define     adConnectUnspecified       -1

// Donde colocamos el cursor ADO??
#define     adUseClient                3
#define     adUseNone                  1
#define     adUseServer                2

// Tipos de Cursores
#define     adOpenDynamic              2
#define     adOpenForwardOnly          0
#define     adOpenKeyset               1
#define     adOpenStatic               3
#define     adOpenUnspecified          -1

// Tipos de bloqueos
#define     adLockBatchOptimistic      4
#define     adLockOptimistic           3
#define     adLockPessimistic          2
#define     adLockReadOnly             1
#define     adLockUnspecified          -1

// Tipos de comandos
#define     adCmdUnspecified           -1
#define     adCmdText                  1
#define     adCmdTable                 2
#define     adCmdStoredProc            4
#define     adCmdUnknown               8
#define     adCmdFile                  256
#define     adCmdTableDirect           512

// Tipos de ejecuciones
#define     adAsyncExecute             0x10 Indicates that the command should execute asynchronously.
#define     adAsyncFetch               0x20 Indicates that the remaining rows after the initial quantity specified in the CacheSize property should be retrieved asynchronously.
#define     adAsyncFetchNonBlocking    0x40 Indicates that the main thread never blocks while retrieving. If the requested row has not been retrieved, the current row automatically moves to the end of the file.
#define     adExecuteNoRecords         0x80 Indicates that the command text is a command or stored procedure that does not return rows (for example, a command that only inserts data). If any rows are retrieved, they are discarded and not returned.
#define     adExecuteStream            0x400 Indicates that the results of a command execution should be returned as a stream.
#define     adExecuteRecord
#define     adOptionUnspecified        -1


